#!/usr/bin/env node
import { inc as a, prerelease as y } from "semver";
import { join as f } from "node:path";
import { execSync as n } from "node:child_process";
import m from "pinyin";
import { readFileSync as h, existsSync as w } from "node:fs";
import p from "chalk";
const u = process.cwd(), S = "/.dc/publish.json", b = "/package.json", N = ({ gitOriginName: e = "origin" }) => {
  try {
    const r = n('git log -1 --pretty=format:"%an"').toString().trim(), s = n('git log -1 --pretty=format:"%ae"').toString().trim(), c = n('git log -1 --pretty=format:"%s"').toString().trim(), t = n("git config user.name").toString().trim(), i = n("git config user.email").toString().trim(), o = n("git rev-parse --abbrev-ref HEAD").toString().trim();
    let l = "";
    try {
      l = n(`git config --get remote.${e}.url`).toString().trim();
    } catch {
      throw new Error(`git remote ${e} 不存在`);
    }
    return {
      lastCommitter: r,
      lastCommitterPinYin: m(r, {
        style: m.STYLE_NORMAL,
        heteronym: !1
      }).join(""),
      lastCommitEmail: s,
      lastCommitMsg: c,
      userName: t,
      userNamePinYin: m(t, {
        style: m.STYLE_NORMAL,
        heteronym: !1
      }).join(""),
      userEmail: i,
      branchName: o,
      remoteUrl: l
    };
  } catch (r) {
    throw console.error("Error fetching git information:", r), r;
  }
}, v = async (e) => {
  const r = h(f(u, b), "utf-8"), s = JSON.parse(r);
  let c = s.name, t = "", i;
  const { version: o } = s;
  if (["major", "minor", "patch"].includes(e))
    t = a(o, e), i = "latest";
  else if (["premajor", "preminor", "prepatch"].includes(e)) {
    const l = y(o);
    l ? (console.log(
      p.yellow("当前版本已经是预发布版本，将会在当前版本基础上进行发布")
    ), l.length === 1 && typeof l[0] == "number" ? t = a(o, "prerelease") : t = o.split("-")[0] + "-0") : t = a(o, e), i = "next";
  } else
    i = "alpha", t = a(o, "prerelease", i);
  if (!t)
    throw new Error("version is empty");
  return {
    name: c,
    version: t,
    tag: i
  };
}, E = () => {
  let e;
  const r = f(u, S);
  if (w(r)) {
    const s = h(r, "utf-8");
    e = JSON.parse(s);
  } else
    console.log(
      p.yellow(`未找到配置文件，将使用默认配置
      { gitOriginName: "origin" }
    `)
    );
  return {
    gitOriginName: "origin",
    ...e || {}
  };
}, C = async (e, r) => {
  console.log("cmd:", e);
  const { type: s, push: c } = r, t = E(), i = N(t);
  console.log("type:", s), console.log("gitInfo:", i);
  const o = await v(s), { version: l } = o;
  if (console.log("npmInfo:", o), n(`npm version ${l} 1>&2`), e === "npm") {
    const { tag: g } = o;
    n(`npm publish --tag ${g} 1>&2`);
  } else if (e === "web") {
    const { webBuild: g } = t;
    g ? n(`${g} 1>&2`) : console.log(p.yellow("webBuild为空，不执行web构建"));
  } else
    throw new Error("未知命令");
  c && (n(`git push ${t.gitOriginName} v${o.version} 1>&2`), n(`git push ${t.gitOriginName} ${i.branchName} 1>&2`)), console.log(p.green("发布成功"));
};
export {
  C as handler
};
